/*
 * 机具转换订单
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MachineChangeController : BaseController
    {
        public MachineChangeController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具转换订单列表

        /// <summary>
        /// 根据条件查询机具转换订单列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MachineChange data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询机具转换订单列表

        /// <summary>
        /// 机具转换订单列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MachineChange data, string UserIdRealName, string UserIdMakerCode, string BackProductTypeSelect, string AuditResultSelect, string BackStoreIdStoreName, string BackStoreIdStoreNo, string BackStoreUserIdMakerCode, string BackStoreUserIdRealName, string OutProductTypeSelect, string OutStoreIdStoreName, string OutStoreIdStoreNo, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("ChangeNo", "1"); //转换单号
            Fields.Add("OutStoreManagerMobile", "1"); //出库仓库联系人手机号


            string condition = " and Status>-1";
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //退回产品类型
            if (!string.IsNullOrEmpty(BackProductTypeSelect))
            {
                condition += " and BackProductType=" + BackProductTypeSelect;
            }
            //审核结果
            if (!string.IsNullOrEmpty(AuditResultSelect))
            {
                condition += " and AuditResult=" + AuditResultSelect;
            }
            //退回仓库名称
            if (!string.IsNullOrEmpty(BackStoreIdStoreName))
            {
                condition += " and BackStoreId in (select BackStoreId from StoreHouseForStoreName where StoreName='" + BackStoreIdStoreName + "')";
            }
            //退回仓库编号
            if (!string.IsNullOrEmpty(BackStoreIdStoreNo))
            {
                condition += " and BackStoreId in (select BackStoreId from StoreHouseForStoreNo where StoreNo='" + BackStoreIdStoreNo + "')";
            }
            //退回仓库归属人创客编号
            if (!string.IsNullOrEmpty(BackStoreUserIdMakerCode))
            {
                condition += " and BackStoreUserId in (select BackStoreUserId from UserForMakerCode where MakerCode='" + BackStoreUserIdMakerCode + "')";
            }
            //退回仓库归属人真实姓名
            if (!string.IsNullOrEmpty(BackStoreUserIdRealName))
            {
                condition += " and BackStoreUserId in (select BackStoreUserId from UserForRealName where RealName='" + BackStoreUserIdRealName + "')";
            }
            //出库产品类型
            if (!string.IsNullOrEmpty(OutProductTypeSelect))
            {
                condition += " and OutProductType=" + OutProductTypeSelect;
            }
            //出库仓库名称
            if (!string.IsNullOrEmpty(OutStoreIdStoreName))
            {
                condition += " and OutStoreId in (select OutStoreId from StoreHouseForStoreName where StoreName='" + OutStoreIdStoreName + "')";
            }
            //出库仓库编号
            if (!string.IsNullOrEmpty(OutStoreIdStoreNo))
            {
                condition += " and OutStoreId in (select OutStoreId from StoreHouseForStoreNo where StoreNo='" + OutStoreIdStoreNo + "')";
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineChange", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");
                //退回产品类型
                dic["BackProductType"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BackProductType"].ToString()));
                //审核结果
                int AuditResult = int.Parse(dic["AuditResult"].ToString());
                if (AuditResult == 0) dic["AuditResult"] = "待审";
                if (AuditResult == 1) dic["AuditResult"] = "通过";
                if (AuditResult == 2) dic["AuditResult"] = "驳回";
                //退回仓库
                int BackStoreId = int.Parse(function.CheckInt(dic["BackStoreId"].ToString()));
                StoreHouse backstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == BackStoreId) ?? new StoreHouse();
                dic["BackStoreIdStoreName"] = backstoreid_StoreHouse.StoreName;
                dic["BackStoreIdStoreNo"] = backstoreid_StoreHouse.StoreNo;
                dic.Remove("BackStoreId");
                //退回仓库归属人
                int BackStoreUserId = int.Parse(function.CheckInt(dic["BackStoreUserId"].ToString()));
                Users backstoreuserid_Users = db.Users.FirstOrDefault(m => m.Id == BackStoreUserId) ?? new Users();
                dic["BackStoreUserIdMakerCode"] = backstoreuserid_Users.MakerCode;
                dic["BackStoreUserIdRealName"] = backstoreuserid_Users.RealName;
                dic.Remove("BackStoreUserId");
                //出库产品类型
                dic["OutProductType"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["OutProductType"].ToString()));
                //出库仓库
                int OutStoreId = int.Parse(function.CheckInt(dic["OutStoreId"].ToString()));
                StoreHouse outstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == OutStoreId) ?? new StoreHouse();
                dic["OutStoreIdStoreName"] = outstoreid_StoreHouse.StoreName;
                dic["OutStoreIdStoreNo"] = outstoreid_StoreHouse.StoreNo;
                dic.Remove("OutStoreId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具转换订单

        /// <summary>
        /// 增加或修改机具转换订单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具转换订单

        /// <summary>
        /// 增加或修改机具转换订单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MachineChange data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("AuditResult", data.AuditResult); //审核结果
            Fields.Add("AuditRemark", data.AuditRemark); //审核备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MachineChange", Fields, 0);
            AddSysLog(data.Id.ToString(), "MachineChange", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具转换订单

        /// <summary>
        /// 增加或修改机具转换订单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            MachineChange editData = db.MachineChange.FirstOrDefault(m => m.Id == Id) ?? new MachineChange();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具转换订单

        /// <summary>
        /// 增加或修改机具转换订单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MachineChange data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("AuditResult", data.AuditResult); //审核结果
            Fields.Add("AuditRemark", data.AuditRemark); //审核备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChange", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MachineChange", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具转换订单信息

        /// <summary>
        /// 删除机具转换订单信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChange", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChange", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChange", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChange", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineChange", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineChange", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MachineChange", Sort, Id);

            AddSysLog(Id.ToString(), "MachineChange", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MachineChange.Add(new MachineChange()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MachineChange", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MachineChange data, string UserIdRealName, string UserIdMakerCode, string BackProductTypeSelect, string AuditResultSelect, string BackStoreIdStoreName, string BackStoreIdStoreNo, string BackStoreUserIdMakerCode, string BackStoreUserIdRealName, string OutProductTypeSelect, string OutStoreIdStoreName, string OutStoreIdStoreNo)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ChangeNo", "1"); //转换单号
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("OutStoreManagerMobile", "1"); //出库仓库联系人手机号


            string condition = " and Status>-1";
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //退回产品类型
            if (!string.IsNullOrEmpty(BackProductTypeSelect))
            {
                condition += " and BackProductType=" + BackProductTypeSelect;
            }
            //审核结果
            if (!string.IsNullOrEmpty(AuditResultSelect))
            {
                condition += " and AuditResult=" + AuditResultSelect;
            }
            //退回仓库名称
            if (!string.IsNullOrEmpty(BackStoreIdStoreName))
            {
                condition += " and BackStoreId in (select BackStoreId from StoreHouseForStoreName where StoreName='" + BackStoreIdStoreName + "')";
            }
            //退回仓库编号
            if (!string.IsNullOrEmpty(BackStoreIdStoreNo))
            {
                condition += " and BackStoreId in (select BackStoreId from StoreHouseForStoreNo where StoreNo='" + BackStoreIdStoreNo + "')";
            }
            //退回仓库归属人创客编号
            if (!string.IsNullOrEmpty(BackStoreUserIdMakerCode))
            {
                condition += " and BackStoreUserId in (select BackStoreUserId from UserForMakerCode where MakerCode='" + BackStoreUserIdMakerCode + "')";
            }
            //退回仓库归属人真实姓名
            if (!string.IsNullOrEmpty(BackStoreUserIdRealName))
            {
                condition += " and BackStoreUserId in (select BackStoreUserId from UserForRealName where RealName='" + BackStoreUserIdRealName + "')";
            }
            //出库产品类型
            if (!string.IsNullOrEmpty(OutProductTypeSelect))
            {
                condition += " and OutProductType=" + OutProductTypeSelect;
            }
            //出库仓库名称
            if (!string.IsNullOrEmpty(OutStoreIdStoreName))
            {
                condition += " and OutStoreId in (select OutStoreId from StoreHouseForStoreName where StoreName='" + OutStoreIdStoreName + "')";
            }
            //出库仓库编号
            if (!string.IsNullOrEmpty(OutStoreIdStoreNo))
            {
                condition += " and OutStoreId in (select OutStoreId from StoreHouseForStoreNo where StoreNo='" + OutStoreIdStoreNo + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineChange", Fields, "Id desc", "0", 1, 20000, condition, "ChangeNo,UserId,BackProductType,ChangeDeviceNum,ChangeTime,AuditBy,AuditResult,AuditRemark,ChangeSnExpand,BackStoreId,Remark,BackStoreUserId,OutProductType,OutStoreId,OutStoreManagerMobile", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");
                //退回产品类型
                dic["BackProductType"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BackProductType"].ToString()));
                //审核结果
                int AuditResult = int.Parse(dic["AuditResult"].ToString());
                if (AuditResult == 0) dic["AuditResult"] = "待审";
                if (AuditResult == 1) dic["AuditResult"] = "通过";
                if (AuditResult == 2) dic["AuditResult"] = "驳回";
                //退回仓库
                int BackStoreId = int.Parse(function.CheckInt(dic["BackStoreId"].ToString()));
                StoreHouse backstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == BackStoreId) ?? new StoreHouse();
                dic["BackStoreIdStoreName"] = backstoreid_StoreHouse.StoreName;
                dic["BackStoreIdStoreNo"] = backstoreid_StoreHouse.StoreNo;
                dic.Remove("BackStoreId");
                //退回仓库归属人
                int BackStoreUserId = int.Parse(function.CheckInt(dic["BackStoreUserId"].ToString()));
                Users backstoreuserid_Users = db.Users.FirstOrDefault(m => m.Id == BackStoreUserId) ?? new Users();
                dic["BackStoreUserIdMakerCode"] = backstoreuserid_Users.MakerCode;
                dic["BackStoreUserIdRealName"] = backstoreuserid_Users.RealName;
                dic.Remove("BackStoreUserId");
                //出库产品类型
                dic["OutProductType"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["OutProductType"].ToString()));
                //出库仓库
                int OutStoreId = int.Parse(function.CheckInt(dic["OutStoreId"].ToString()));
                StoreHouse outstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == OutStoreId) ?? new StoreHouse();
                dic["OutStoreIdStoreName"] = outstoreid_StoreHouse.StoreName;
                dic["OutStoreIdStoreNo"] = outstoreid_StoreHouse.StoreNo;
                dic.Remove("OutStoreId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ChangeNo", "转换单号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("BackProductType", "退回产品类型");
            ReturnFields.Add("ChangeDeviceNum", "转换机具数量");
            ReturnFields.Add("ChangeTime", "转换时间");
            ReturnFields.Add("AuditBy", "审核人");
            ReturnFields.Add("AuditResult", "审核结果");
            ReturnFields.Add("AuditRemark", "审核备注");
            ReturnFields.Add("ChangeSnExpand", "转换机器SN来源");
            ReturnFields.Add("BackStoreIdStoreName", "退回仓库名称");
            ReturnFields.Add("BackStoreIdStoreNo", "退回仓库编号");
            ReturnFields.Add("Remark", "订单备注");
            ReturnFields.Add("BackStoreUserIdMakerCode", "退回仓库归属人创客编号");
            ReturnFields.Add("BackStoreUserIdRealName", "退回仓库归属人真实姓名");
            ReturnFields.Add("OutProductType", "出库产品类型");
            ReturnFields.Add("OutStoreIdStoreName", "出库仓库名称");
            ReturnFields.Add("OutStoreIdStoreNo", "出库仓库编号");
            ReturnFields.Add("OutStoreManagerMobile", "出库仓库联系人手机号");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MachineChange", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
